CWIS Developer Documentation

- Home
- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
MetadataField Class Reference

Object representing a locally-defined type of metadata field. More...

## Public Member Functions
| Status ()
| Get current error status of object. More...
| Type ($NewValue=DB_NOVALUE)
| Get/set type of metadata field (enumerated value). More...
| TypeAsName ()
| Get type of field as string. More...
| SchemaId ()
| Get ID of schema for field. More...
| GetDisplayName ()
| Get display name for field. More...
| Name ($NewName=DB_NOVALUE)
| Get/set name of field. More...
| Label ($NewLabel=DB_NOVALUE)
| Get/set label for field. More...
| GetAllowedConversionTypes ()
| Get metadata field types that this field can be converted to. More...
| IsTempItem ($NewSetting=NULL)
| Get/set whether field is temporary instance. More...
| AuthoringPrivileges (PrivilegeSet $NewValue=NULL)
| Get/set privileges that allowing authoring values for this field. More...
| EditingPrivileges (PrivilegeSet $NewValue=NULL)
| Get/set privileges that allowing editing values for this field. More...
| ViewingPrivileges (PrivilegeSet $NewValue=NULL)
| Get/set privileges that allowing viewing values for this field. More...
| PreviewingPrivileges (PrivilegeSet $NewValue=NULL)
| Get/set privileges that allowing previewing values for this field. More...
| Id ()
| Get metadata field ID. More...
| DBFieldName ()
| Get base name of database column used to store metadata field value. More...
| Description ($NewValue=DB_NOVALUE)
| Get/set field description. More...
| Instructions ($NewValue=DB_NOVALUE)
| Get/set field instructions. More...
| Owner ($NewValue=DB_NOVALUE)
| Get/set field owner. More...
| Enabled ($NewValue=DB_NOVALUE)
| Get/set whether field is enabled. More...
| Optional ($NewValue=DB_NOVALUE)
| Get/set whether a value is required for this field. More...
| Editable ($NewValue=DB_NOVALUE)
| Get/set whether this field is editable. More...
| AllowMultiple ($NewValue=DB_NOVALUE)
| Get/set whether to allow multiple values for field. More...
| IncludeInKeywordSearch ($NewValue=DB_NOVALUE)
| Get/set whether to include field in keyword search. More...
| IncludeInAdvancedSearch ($NewValue=DB_NOVALUE)
| Get/set whether to include field in advanced search. More...
| IncludeInFacetedSearch ($NewValue=DB_NOVALUE)
| Get/set whether to include field in faceted search. More...
| IncludeInSortOptions ($NewValue=DB_NOVALUE)
| Get/set whether to include field in search result sort options. More...
| IncludeInRecommender ($NewValue=DB_NOVALUE)
| Get/set whether to include field in recommender system comparisons. More...
| CopyOnResourceDuplication ($NewValue=DB_NOVALUE)
| Get/set whether to duplciate this field when a resource is duplicated. More...
| TextFieldSize ($NewValue=DB_NOVALUE)
| MaxLength ($NewValue=DB_NOVALUE)
| ParagraphRows ($NewValue=DB_NOVALUE)
| ParagraphCols ($NewValue=DB_NOVALUE)
| MinValue ($NewValue=DB_NOVALUE)
| MaxValue ($NewValue=DB_NOVALUE)
| FlagOnLabel ($NewValue=DB_NOVALUE)
| FlagOffLabel ($NewValue=DB_NOVALUE)
| DateFormat ($NewValue=DB_NOVALUE)
| SearchWeight ($NewValue=DB_NOVALUE)
| RecommenderWeight ($NewValue=DB_NOVALUE)
| MaxHeight ($NewValue=DB_NOVALUE)
| MaxWidth ($NewValue=DB_NOVALUE)
| MaxPreviewHeight ($NewValue=DB_NOVALUE)
| MaxPreviewWidth ($NewValue=DB_NOVALUE)
| MaxThumbnailHeight ($NewValue=DB_NOVALUE)
| MaxThumbnailWidth ($NewValue=DB_NOVALUE)
| DefaultAltText ($NewValue=DB_NOVALUE)
| UsesQualifiers ($NewValue=DB_NOVALUE)
| ShowQualifiers ($NewValue=DB_NOVALUE)
| DefaultQualifier ($NewValue=DB_NOVALUE)
| AllowHTML ($NewValue=DB_NOVALUE)
| UseWysiwygEditor ($NewValue=DB_NOVALUE)
| UseForOaiSets ($NewValue=DB_NOVALUE)
| DisplayAsListForAdvancedSearch ($NewValue=DB_NOVALUE)
| OptionListThreshold ($NewValue=DB_NOVALUE)
| AjaxThreshold ($NewValue=DB_NOVALUE)
| NumAjaxResults ($NewValue=DB_NOVALUE)
| ViewingPrivilege ($NewValue=DB_NOVALUE)
| AuthoringPrivilege ($NewValue=DB_NOVALUE)
| EditingPrivilege ($NewValue=DB_NOVALUE)
| ImagePreviewPrivilege ($NewValue=DB_NOVALUE)
| TreeBrowsingPrivilege ($NewValue=DB_NOVALUE)
| EnableOnOwnerReturn ($NewValue=DB_NOVALUE)
| ViewingUserIsValue ($NewValue=DB_NOVALUE)
| AuthoringUserIsValue ($NewValue=DB_NOVALUE)
| EditingUserIsValue ($NewValue=DB_NOVALUE)
| ViewingUserValue ($NewValue=DB_NOVALUE)
| AuthoringUserValue ($NewValue=DB_NOVALUE)
| EditingUserValue ($NewValue=DB_NOVALUE)
| RequiredBySPT ($NewValue=DB_NOVALUE)
| UserPrivilegeRestrictions ($NewValue=DB_NOVALUE)
| PointPrecision ($NewValue=DB_NOVALUE)
| PointDecimalDigits ($NewValue=DB_NOVALUE)
| DefaultValue ($NewValue=DB_NOVALUE)
| UpdateMethod ($NewValue=DB_NOVALUE)
| Get/set method by which field is updated. More...
| GetPossibleValues ($MaxNumberOfValues=NULL, $Offset=0)
| GetCountOfPossibleValues ()
| GetIdForValue ($Value)
| GetValueForId ($Id)
| ValueUseCount ($Value)
| Check how many times a specific value is currently used for this field. More...
| HasItemLevelQualifiers ($NewValue=DB_NOVALUE)
| AssociatedQualifierList ()
| UnassociatedQualifierList ()
| AddQualifier ($Qualifier)
| Associate qualifier with field. More...
| AssociateWithQualifier ($Qualifier)
| DEPRECATED METHOD. More...
| UnassociateWithQualifier ($QualifierIdOrObject)
| GetFactory ()
| Viewable ()
| This function has been deprecated and should not be used. More...
| __construct ($FieldId)
| Object contstructor, used to load an existing metadata field. More...
| SetDefaults ()
| Set defaults values for the field. More...
| Drop ()

## Static Public Member Functions
static | Create ($SchemaId, $FieldType, $FieldName, $Optional=NULL, $DefaultValue=NULL)
| Create a new metadata field. More...

## Public Attributes
const | UPDATEMETHOD_NOAUTOUPDATE = "NoAutoUpdate"
const | UPDATEMETHOD_ONRECORDCREATE = "OnRecordCreate"
const | UPDATEMETHOD_BUTTON = "Button"
const | UPDATEMETHOD_ONRECORDEDIT = "OnRecordEdit"
const | UPDATEMETHOD_ONRECORDCHANGE = "OnRecordChange"
const | USERISVALUE_OR = -1
const | USERISVALUE_UNSET = 0
const | USERISVALUE_AND = 1

## Static Public Attributes
static | $FieldTypeHumanEnums
| A map of metadata field types to human-readable strings. More...
static | $FieldTypeDBEnums
static | $FieldTypeDBAllowedEnums
static | $FieldTypePHPEnums
static | $UpdateTypes
static | $FixedDefaults
| The metadata field defaults that are the same for all field types. More...
static | $TypeBasedDefaults
| The metadata field defaults that vary depending on the field type. More...

## Detailed Description

Object representing a locally-defined type of metadata field.

Definition at line 13 of file MetadataField.php.

## Constructor & Destructor Documentation

MetadataField::__construct | ( |  | $FieldId | ) |

Object contstructor, used to load an existing metadata field.

To create new fields, use

Parameters

  int | $FieldId | ID of metadata field to load.

Returns
  object New MetadataField object.

Definition at line 1583 of file MetadataField.php.

References AuthoringPrivileges(), EditingPrivileges(), Id(), MetadataSchema\MDFSTAT_OK, PreviewingPrivileges(), and ViewingPrivileges().

## Member Function Documentation

MetadataField::AddQualifier | ( |  | $Qualifier | ) |

Associate qualifier with field.

Parameters

  mixed | $Qualifier | Qualifer ID, name, or object.

Definition at line 1286 of file MetadataField.php.

References Id().

Referenced by AssociateWithQualifier().

Here is the caller graph for this function:

MetadataField::AjaxThreshold | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 698 of file MetadataField.php.

MetadataField::AllowHTML | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 673 of file MetadataField.php.

MetadataField::AllowMultiple | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to allow multiple values for field.

Parameters

  bool | $NewValue | TRUE to allow multiple values, or FALSE if only one value may be set. (OPTIONAL)

Returns
  bool TRUE if field allows multiple values, otherwise FALSE.

Definition at line 499 of file MetadataField.php.

Referenced by DefaultValue().

Here is the caller graph for this function:

MetadataField::AssociatedQualifierList | ( |  | ) |

Definition at line 1247 of file MetadataField.php.

Referenced by UnassociatedQualifierList().

Here is the caller graph for this function:

MetadataField::AssociateWithQualifier | ( |  | $Qualifier | ) |

DEPRECATED METHOD.

Parameters

  mixed | $Qualifier |

See also
  AddQualifier()

Definition at line 1320 of file MetadataField.php.

References AddQualifier().

MetadataField::AuthoringPrivilege | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 720 of file MetadataField.php.

References AuthoringPrivileges(), and DB_NOVALUE.

MetadataField::AuthoringPrivileges | ( | PrivilegeSet | $NewValue = `NULL` | ) |

Get/set privileges that allowing authoring values for this field.

Parameters

  object | $NewValue | New PrivilegeSet value. (OPTIONAL)

Returns
  object PrivilegeSet that allows authoring.

Definition at line 340 of file MetadataField.php.

Referenced by __construct(), and AuthoringPrivilege().

Here is the caller graph for this function:

MetadataField::AuthoringUserIsValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 779 of file MetadataField.php.

MetadataField::AuthoringUserValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 795 of file MetadataField.php.

MetadataField::CopyOnResourceDuplication | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to duplciate this field when a resource is duplicated.

Parameters

  bool | $NewValue | TRUE

Definition at line 563 of file MetadataField.php.

static MetadataField::Create | ( |  | $SchemaId,
|  |  | $FieldType,
|  |  | $FieldName,
|  |  | $Optional = `NULL`,
|  |  | $DefaultValue = `NULL`
| ) |  |
| static

Create a new metadata field.

Parameters

  int | $SchemaId | ID of schema in which to place field.
  enum | $FieldType | Metadata field type.
  string | $FieldName | Name of metadata field.
  bool | $Optional | If FALSE, field must always have a value. (OPTIONAL, defaults to TRUE)
  mixed | $DefaultValue | Default value for field.

Returns
  object New MetadataField object.

Exceptions

  InvalidArgumentException | if field type is invalid.
  InvalidArgumentException | if field name is duplicates name of another existing field.

Definition at line 1499 of file MetadataField.php.

Referenced by MetadataSchema\AddField().

Here is the caller graph for this function:

MetadataField::DateFormat | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 608 of file MetadataField.php.

MetadataField::DBFieldName | ( |  | ) |

Get base name of database column used to store metadata field value.

(Only valid for some field types.)

Returns
  string Column name.

Definition at line 425 of file MetadataField.php.

Referenced by HasItemLevelQualifiers().

Here is the caller graph for this function:

MetadataField::DefaultAltText | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 653 of file MetadataField.php.

MetadataField::DefaultQualifier | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 668 of file MetadataField.php.

MetadataField::DefaultValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 884 of file MetadataField.php.

References AllowMultiple(), DB_NOVALUE, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_POINT, and Type().

MetadataField::Description | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set field description.

Parameters

  string | New description. (OPTIONAL)

Returns
  string Current field description.

Definition at line 435 of file MetadataField.php.

MetadataField::DisplayAsListForAdvancedSearch | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 688 of file MetadataField.php.

MetadataField::Drop | ( |  | ) |

Definition at line 1797 of file MetadataField.php.

References MetadataFieldOrder\GetOrdersForSchema(), Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_DATE, MetadataSchema\MDFTYPE_FILE, MetadataSchema\MDFTYPE_FLAG, MetadataSchema\MDFTYPE_IMAGE, MetadataSchema\MDFTYPE_NUMBER, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_PARAGRAPH, MetadataSchema\MDFTYPE_POINT, MetadataSchema\MDFTYPE_REFERENCE, MetadataSchema\MDFTYPE_TEXT, MetadataSchema\MDFTYPE_TIMESTAMP, MetadataSchema\MDFTYPE_TREE, MetadataSchema\MDFTYPE_URL, MetadataSchema\MDFTYPE_USER, and SchemaId().

MetadataField::Editable | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether this field is editable.

Parameters

  bool | $NewValue | TRUE to indicate that field is editable, or FALSE to indicate it non-editable. (OPTIONAL)

Returns
  bool TRUE if field is editable, otherwise FALSE.

Definition at line 488 of file MetadataField.php.

MetadataField::EditingPrivilege | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 732 of file MetadataField.php.

References DB_NOVALUE, and EditingPrivileges().

MetadataField::EditingPrivileges | ( | PrivilegeSet | $NewValue = `NULL` | ) |

Get/set privileges that allowing editing values for this field.

Parameters

  object | $NewValue | New PrivilegeSet value. (OPTIONAL)

Returns
  object PrivilegeSet that allows editing.

Definition at line 359 of file MetadataField.php.

Referenced by __construct(), EditingPrivilege(), and Viewable().

Here is the caller graph for this function:

MetadataField::EditingUserIsValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 785 of file MetadataField.php.

MetadataField::EditingUserValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 800 of file MetadataField.php.

MetadataField::Enabled | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether field is enabled.

Parameters

  bool | $NewValue | TRUE to enable field, or FALSE to disable. (OPTIONAL)

Returns
  bool TRUE if field is enabled, otherwise FALSE.

Definition at line 466 of file MetadataField.php.

Referenced by Viewable().

Here is the caller graph for this function:

MetadataField::EnableOnOwnerReturn | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 769 of file MetadataField.php.

MetadataField::FlagOffLabel | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 603 of file MetadataField.php.

Referenced by GetPossibleValues().

Here is the caller graph for this function:

MetadataField::FlagOnLabel | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 598 of file MetadataField.php.

Referenced by GetPossibleValues().

Here is the caller graph for this function:

MetadataField::GetAllowedConversionTypes | ( |  | ) |

Get metadata field types that this field can be converted to.

Returns
  array Array with constants (MDFTYPE_ values) for the index and field type strings for the values.

Definition at line 182 of file MetadataField.php.

References MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_DATE, MetadataSchema\MDFTYPE_FILE, MetadataSchema\MDFTYPE_FLAG, MetadataSchema\MDFTYPE_IMAGE, MetadataSchema\MDFTYPE_NUMBER, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_PARAGRAPH, MetadataSchema\MDFTYPE_REFERENCE, MetadataSchema\MDFTYPE_TEXT, MetadataSchema\MDFTYPE_TIMESTAMP, MetadataSchema\MDFTYPE_TREE, MetadataSchema\MDFTYPE_URL, MetadataSchema\MDFTYPE_USER, and Type().

MetadataField::GetCountOfPossibleValues | ( |  | ) |

Definition at line 1037 of file MetadataField.php.

References GetPossibleValues(), Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_FLAG, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_TREE, MetadataSchema\MDFTYPE_USER, and Type().

MetadataField::GetDisplayName | ( |  | ) |

Get display name for field.

Returns label if available, or field name if label is not set for field.

Returns
  string Display name.

Definition at line 83 of file MetadataField.php.

References Label(), and Name().

MetadataField::GetFactory | ( |  | ) |

Definition at line 1342 of file MetadataField.php.

References Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_TREE, and Type().

MetadataField::GetIdForValue | ( |  | $Value | ) |

Definition at line 1075 of file MetadataField.php.

References Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_TREE, and Type().

MetadataField::GetPossibleValues | ( |  | $MaxNumberOfValues = `NULL`,
|  |  | $Offset = `0`
| ) |  |

Definition at line 962 of file MetadataField.php.

References FlagOffLabel(), FlagOnLabel(), Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_FLAG, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_TREE, MetadataSchema\MDFTYPE_USER, Type(), and UserPrivilegeRestrictions().

Referenced by GetCountOfPossibleValues().

Here is the caller graph for this function:

MetadataField::GetValueForId | ( |  | $Id | ) |

Definition at line 1107 of file MetadataField.php.

References Id(), MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_TREE, and Type().

MetadataField::HasItemLevelQualifiers | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 1210 of file MetadataField.php.

References DB_NOVALUE, and DBFieldName().

MetadataField::Id | ( |  | ) |

Get metadata field ID.

Returns
  int Field ID.

Definition at line 415 of file MetadataField.php.

Referenced by __construct(), AddQualifier(), Drop(), GetCountOfPossibleValues(), GetFactory(), GetIdForValue(), GetPossibleValues(), GetValueForId(), IsTempItem(), PointDecimalDigits(), and PointPrecision().

Here is the caller graph for this function:

MetadataField::ImagePreviewPrivilege | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 744 of file MetadataField.php.

References DB_NOVALUE, and ViewingPrivileges().

MetadataField::IncludeInAdvancedSearch | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to include field in advanced search.

Parameters

  bool | $NewValue | TRUE to include field, or FALSE if field should not be included. (OPTIONAL)

Returns
  bool TRUE if field should be included, otherwise FALSE.

Definition at line 521 of file MetadataField.php.

MetadataField::IncludeInFacetedSearch | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to include field in faceted search.

Parameters

  bool | $NewValue | TRUE to include field, or FALSE if field should not be included. (OPTIONAL)

Returns
  bool TRUE if field should be included, otherwise FALSE.

Definition at line 532 of file MetadataField.php.

MetadataField::IncludeInKeywordSearch | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to include field in keyword search.

Parameters

  bool | $NewValue | TRUE to include field, or FALSE if field should not be included. (OPTIONAL)

Returns
  bool TRUE if field should be included, otherwise FALSE.

Definition at line 510 of file MetadataField.php.

MetadataField::IncludeInRecommender | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to include field in recommender system comparisons.

Parameters

  bool | $NewValue | TRUE to include field, or FALSE if field should not be included. (OPTIONAL)

Returns
  bool TRUE if field should be included, otherwise FALSE.

Definition at line 554 of file MetadataField.php.

MetadataField::IncludeInSortOptions | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether to include field in search result sort options.

Parameters

  bool | $NewValue | TRUE to include field, or FALSE if field should not be included. (OPTIONAL)

Returns
  bool TRUE if field should be included, otherwise FALSE.

Definition at line 543 of file MetadataField.php.

MetadataField::Instructions | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set field instructions.

Parameters

  string | New instructions. (OPTIONAL)

Returns
  string Current field instructions.

Definition at line 445 of file MetadataField.php.

MetadataField::IsTempItem | ( |  | $NewSetting = `NULL` | ) |

Get/set whether field is temporary instance.

Parameters

  bool | $NewSetting | If TRUE, field is a temporary instance, or if FALSE, field is non-temporary. (OPTIONAL)

Returns
  bool If TRUE, field is a temporary instance, or if FALSE, field is non-temporary.

Definition at line 244 of file MetadataField.php.

References Id(), MetadataSchema\MDFSTAT_ILLEGALNAME, Name(), and SchemaId().

MetadataField::Label | ( |  | $NewLabel = `DB_NOVALUE` | ) |

Get/set label for field.

Parameters

  string | $NewLabel | New label for field. (OPTIONAL)

Returns
  string Current label for field.

Definition at line 151 of file MetadataField.php.

References DB_NOVALUE, and MetadataSchema\MDFSTAT_ILLEGALLABEL.

Referenced by GetDisplayName().

Here is the caller graph for this function:

MetadataField::MaxHeight | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 623 of file MetadataField.php.

MetadataField::MaxLength | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 573 of file MetadataField.php.

MetadataField::MaxPreviewHeight | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 633 of file MetadataField.php.

MetadataField::MaxPreviewWidth | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 638 of file MetadataField.php.

MetadataField::MaxThumbnailHeight | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 643 of file MetadataField.php.

MetadataField::MaxThumbnailWidth | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 648 of file MetadataField.php.

MetadataField::MaxValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 593 of file MetadataField.php.

MetadataField::MaxWidth | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 628 of file MetadataField.php.

MetadataField::MinValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 588 of file MetadataField.php.

MetadataField::Name | ( |  | $NewName = `DB_NOVALUE` | ) |

Get/set name of field.

Field names are limited to alphanumerics, spaces, and parentheses.

Parameters

  string | $NewName | New field name. (OPTIONAL)

Returns
  string Current field name.

Definition at line 94 of file MetadataField.php.

References DB_NOVALUE, MetadataSchema\MDFSTAT_DUPLICATENAME, MetadataSchema\MDFSTAT_ILLEGALNAME, and MetadataSchema\MDFSTAT_OK.

Referenced by GetDisplayName(), IsTempItem(), and SetDefaults().

Here is the caller graph for this function:

MetadataField::NumAjaxResults | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 703 of file MetadataField.php.

MetadataField::Optional | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set whether a value is required for this field.

Parameters

  bool | $NewValue | TRUE to require a value, or FALSE to make entering a value optional. (OPTIONAL)

Returns
  bool TRUE if a value is required, otherwise FALSE.

Definition at line 477 of file MetadataField.php.

MetadataField::OptionListThreshold | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 693 of file MetadataField.php.

MetadataField::Owner | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set field owner.

Parameters

  string | New owner. (OPTIONAL)

Returns
  string Current owner.

Definition at line 455 of file MetadataField.php.

MetadataField::ParagraphCols | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 583 of file MetadataField.php.

MetadataField::ParagraphRows | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 578 of file MetadataField.php.

MetadataField::PointDecimalDigits | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 859 of file MetadataField.php.

References DB_NOVALUE, Id(), MetadataSchema\MDFTYPE_POINT, and Type().

MetadataField::PointPrecision | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 835 of file MetadataField.php.

References DB_NOVALUE, Id(), MetadataSchema\MDFTYPE_POINT, and Type().

MetadataField::PreviewingPrivileges | ( | PrivilegeSet | $NewValue = `NULL` | ) |

Get/set privileges that allowing previewing values for this field.

Parameters

  object | $NewValue | New PrivilegeSet value. (OPTIONAL)

Returns
  object PrivilegeSet that allows previewing.

Definition at line 397 of file MetadataField.php.

Referenced by __construct().

Here is the caller graph for this function:

MetadataField::RecommenderWeight | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 618 of file MetadataField.php.

MetadataField::RequiredBySPT | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 805 of file MetadataField.php.

MetadataField::SchemaId | ( |  | ) |

Get ID of schema for field.

Returns
  int Schema ID.

Definition at line 73 of file MetadataField.php.

Referenced by Drop(), and IsTempItem().

Here is the caller graph for this function:

MetadataField::SearchWeight | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 613 of file MetadataField.php.

MetadataField::SetDefaults | ( |  | ) |

Set defaults values for the field.

Returns
  void

Definition at line 1775 of file MetadataField.php.

References Name(), Type(), and UpdateMethod().

MetadataField::ShowQualifiers | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 663 of file MetadataField.php.

MetadataField::Status | ( |  | ) |

Get current error status of object.

Returns
  int Error status value drawn from MDFSTAT constants defined in the MetadataSchema class.

Definition at line 34 of file MetadataField.php.

MetadataField::TextFieldSize | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 568 of file MetadataField.php.

MetadataField::TreeBrowsingPrivilege | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 757 of file MetadataField.php.

References DB_NOVALUE, and ViewingPrivileges().

MetadataField::Type | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set type of metadata field (enumerated value).

Types are MDFTYPE_ constants defined in the MetadataSchema class.

Parameters

  enum | $NewValue | New type for field. (OPTIONAL)

Returns
  enum Current type for field.

Definition at line 45 of file MetadataField.php.

References DB_NOVALUE.

Referenced by DefaultValue(), GetAllowedConversionTypes(), GetCountOfPossibleValues(), GetFactory(), GetIdForValue(), GetPossibleValues(), GetValueForId(), PointDecimalDigits(), PointPrecision(), SetDefaults(), and ValueUseCount().

Here is the caller graph for this function:

MetadataField::TypeAsName | ( |  | ) |

Get type of field as string.

Returns
  string Field type.

Definition at line 64 of file MetadataField.php.

MetadataField::UnassociatedQualifierList | ( |  | ) |

Definition at line 1269 of file MetadataField.php.

References AssociatedQualifierList().

MetadataField::UnassociateWithQualifier | ( |  | $QualifierIdOrObject | ) |

Definition at line 1326 of file MetadataField.php.

MetadataField::UpdateMethod | ( |  | $NewValue = `DB_NOVALUE` | ) |

Get/set method by which field is updated.

Parameters

  string | $NewValue | New update method.

Returns
  Existing update method.

Definition at line 954 of file MetadataField.php.

Referenced by SetDefaults().

Here is the caller graph for this function:

MetadataField::UseForOaiSets | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 683 of file MetadataField.php.

MetadataField::UserPrivilegeRestrictions | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 810 of file MetadataField.php.

References DB_NOVALUE.

Referenced by GetPossibleValues().

Here is the caller graph for this function:

MetadataField::UsesQualifiers | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 658 of file MetadataField.php.

MetadataField::UseWysiwygEditor | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 678 of file MetadataField.php.

MetadataField::ValueUseCount | ( |  | $Value | ) |

Check how many times a specific value is currently used for this field.

This method is not valid for Date fields.

Parameters

  mixed | $Value | Value to check. For Flag, Tree, Option, Image, and Controlled Name fields this must be an ID or an appropriate object. For Point fields this must be an associative array with two values with "X" and "Y" indexes. Date fields are not supported. For other field types, the literal value to check should be passed in.

Returns
  Number of times values is currently used.

Definition at line 1147 of file MetadataField.php.

References MetadataSchema\MDFTYPE_CONTROLLEDNAME, MetadataSchema\MDFTYPE_FILE, MetadataSchema\MDFTYPE_FLAG, MetadataSchema\MDFTYPE_IMAGE, MetadataSchema\MDFTYPE_NUMBER, MetadataSchema\MDFTYPE_OPTION, MetadataSchema\MDFTYPE_PARAGRAPH, MetadataSchema\MDFTYPE_POINT, MetadataSchema\MDFTYPE_TEXT, MetadataSchema\MDFTYPE_TIMESTAMP, MetadataSchema\MDFTYPE_TREE, MetadataSchema\MDFTYPE_URL, MetadataSchema\MDFTYPE_USER, and Type().

MetadataField::Viewable | ( |  | ) |

This function has been deprecated and should not be used.

Deprecated:

Definition at line 1367 of file MetadataField.php.

References EditingPrivileges(), Enabled(), and ViewingPrivileges().

MetadataField::ViewingPrivilege | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 708 of file MetadataField.php.

References DB_NOVALUE, and ViewingPrivileges().

MetadataField::ViewingPrivileges | ( | PrivilegeSet | $NewValue = `NULL` | ) |

Get/set privileges that allowing viewing values for this field.

Parameters

  object | $NewValue | New PrivilegeSet value. (OPTIONAL)

Returns
  object PrivilegeSet that allows viewing.

Definition at line 378 of file MetadataField.php.

Referenced by __construct(), ImagePreviewPrivilege(), TreeBrowsingPrivilege(), Viewable(), and ViewingPrivilege().

Here is the caller graph for this function:

MetadataField::ViewingUserIsValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 774 of file MetadataField.php.

MetadataField::ViewingUserValue | ( |  | $NewValue = `DB_NOVALUE` | ) |

Definition at line 790 of file MetadataField.php.

## Member Data Documentation

MetadataField::$FieldTypeDBAllowedEnums
| static

Initial value:
= array(
MetadataSchema::MDFTYPE_TEXT => "Text",
MetadataSchema::MDFTYPE_PARAGRAPH => "Paragraph",
MetadataSchema::MDFTYPE_NUMBER => "Number",
MetadataSchema::MDFTYPE_DATE => "Date",
MetadataSchema::MDFTYPE_TIMESTAMP => "TimeStamp",
MetadataSchema::MDFTYPE_FLAG => "Flag",
MetadataSchema::MDFTYPE_TREE => "Tree",
MetadataSchema::MDFTYPE_CONTROLLEDNAME => "ControlledName",
MetadataSchema::MDFTYPE_OPTION => "Option",
MetadataSchema::MDFTYPE_USER => "User",
MetadataSchema::MDFTYPE_IMAGE => "Still Image",
MetadataSchema::MDFTYPE_FILE => "File",
MetadataSchema::MDFTYPE_URL => "Url",
MetadataSchema::MDFTYPE_POINT => "Point",
MetadataSchema::MDFTYPE_REFERENCE => "Reference"
)

Definition at line 1443 of file MetadataField.php.

Referenced by MetadataSchema\GetAllowedFieldTypes().

MetadataField::$FieldTypeDBEnums
| static

Initial value:
= array(
MetadataSchema::MDFTYPE_TEXT => "Text",
MetadataSchema::MDFTYPE_PARAGRAPH => "Paragraph",
MetadataSchema::MDFTYPE_NUMBER => "Number",
MetadataSchema::MDFTYPE_DATE => "Date",
MetadataSchema::MDFTYPE_TIMESTAMP => "TimeStamp",
MetadataSchema::MDFTYPE_FLAG => "Flag",
MetadataSchema::MDFTYPE_TREE => "Tree",
MetadataSchema::MDFTYPE_CONTROLLEDNAME => "ControlledName",
MetadataSchema::MDFTYPE_OPTION => "Option",
MetadataSchema::MDFTYPE_USER => "User",
MetadataSchema::MDFTYPE_IMAGE => "Still Image",
MetadataSchema::MDFTYPE_FILE => "File",
MetadataSchema::MDFTYPE_URL => "Url",
MetadataSchema::MDFTYPE_POINT => "Point",
MetadataSchema::MDFTYPE_REFERENCE => "Reference"
)

Definition at line 1426 of file MetadataField.php.

Referenced by MetadataSchema\GetFieldTypes(), and HumanMetadataField\Type().

array MetadataField::$FieldTypeHumanEnums
| static

Initial value:
= array(
MetadataSchema::MDFTYPE_TEXT => "Text",
MetadataSchema::MDFTYPE_PARAGRAPH => "Paragraph",
MetadataSchema::MDFTYPE_NUMBER => "Number",
MetadataSchema::MDFTYPE_DATE => "Date",
MetadataSchema::MDFTYPE_TIMESTAMP => "Timestamp",
MetadataSchema::MDFTYPE_FLAG => "Flag",
MetadataSchema::MDFTYPE_TREE => "Tree",
MetadataSchema::MDFTYPE_CONTROLLEDNAME => "Controlled Name",
MetadataSchema::MDFTYPE_OPTION => "Option",
MetadataSchema::MDFTYPE_USER => "User",
MetadataSchema::MDFTYPE_IMAGE => "Image",
MetadataSchema::MDFTYPE_FILE => "File",
MetadataSchema::MDFTYPE_URL => "URL",
MetadataSchema::MDFTYPE_POINT => "Point",
MetadataSchema::MDFTYPE_REFERENCE => "Reference")

A map of metadata field types to human-readable strings.

Definition at line 1408 of file MetadataField.php.

MetadataField::$FieldTypePHPEnums
| static

Initial value:
= array(
"Text" => MetadataSchema::MDFTYPE_TEXT,
"Paragraph" => MetadataSchema::MDFTYPE_PARAGRAPH,
"Number" => MetadataSchema::MDFTYPE_NUMBER,
"Date" => MetadataSchema::MDFTYPE_DATE,
"TimeStamp" => MetadataSchema::MDFTYPE_TIMESTAMP,
"Flag" => MetadataSchema::MDFTYPE_FLAG,
"Tree" => MetadataSchema::MDFTYPE_TREE,
"ControlledName" => MetadataSchema::MDFTYPE_CONTROLLEDNAME,
"Option" => MetadataSchema::MDFTYPE_OPTION,
"User" => MetadataSchema::MDFTYPE_USER,
"Still Image" => MetadataSchema::MDFTYPE_IMAGE,
"File" => MetadataSchema::MDFTYPE_FILE,
"Url" => MetadataSchema::MDFTYPE_URL,
"Point" => MetadataSchema::MDFTYPE_POINT,
"Reference" => MetadataSchema::MDFTYPE_REFERENCE
)

Definition at line 1460 of file MetadataField.php.

Referenced by MetadataSchema\GetFields().

array MetadataField::$FixedDefaults
| static

The metadata field defaults that are the same for all field types.

Definition at line 1642 of file MetadataField.php.

array MetadataField::$TypeBasedDefaults
| static

The metadata field defaults that vary depending on the field type.

Definition at line 1692 of file MetadataField.php.

MetadataField::$UpdateTypes
| static

Initial value:
= array(
self::UPDATEMETHOD_NOAUTOUPDATE => "Do not update automatically",
self::UPDATEMETHOD_ONRECORDCREATE => "Update on record creation",
self::UPDATEMETHOD_BUTTON => "Provide an update button",
self::UPDATEMETHOD_ONRECORDEDIT => "Update when record is edited",
self::UPDATEMETHOD_ONRECORDCHANGE => "Update when record is changed"
)

Definition at line 1478 of file MetadataField.php.

Referenced by HumanMetadataField\UpdateMethod().

const MetadataField::UPDATEMETHOD_BUTTON = "Button"

Definition at line 20 of file MetadataField.php.

const MetadataField::UPDATEMETHOD_NOAUTOUPDATE = "NoAutoUpdate"

Definition at line 18 of file MetadataField.php.

const MetadataField::UPDATEMETHOD_ONRECORDCHANGE = "OnRecordChange"

Definition at line 22 of file MetadataField.php.

const MetadataField::UPDATEMETHOD_ONRECORDCREATE = "OnRecordCreate"

Definition at line 19 of file MetadataField.php.

Referenced by Resource\Create().

const MetadataField::UPDATEMETHOD_ONRECORDEDIT = "OnRecordEdit"

Definition at line 21 of file MetadataField.php.

Referenced by CWUserFactory\CreateNewUser().

const MetadataField::USERISVALUE_AND = 1

Definition at line 27 of file MetadataField.php.

const MetadataField::USERISVALUE_OR = -1

Definition at line 25 of file MetadataField.php.

const MetadataField::USERISVALUE_UNSET = 0

Definition at line 26 of file MetadataField.php.

The documentation for this class was generated from the following file:

- objects/MetadataField.php